#include <Adafruit_NeoPixel.h>

#define Pl1RED_PIN 11
#define Pl1GREEN_PIN 12
#define Pl1BLUE_PIN 13

#define Pl2RED_PIN 5
#define Pl2GREEN_PIN 9
#define Pl2BLUE_PIN 10

#define BUZZER_PIN 6

#define GAMEBOARD_LED_STRIP 2
#define PLAYER_SELECT_STRIP 3

#define PIXELS 7 * 7
#define NUMPIXEL 7

Adafruit_NeoPixel gamaeBoard(PIXELS, GAMEBOARD_LED_STRIP, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel playerSpotSelect(NUMPIXEL, PLAYER_SELECT_STRIP, NEO_GRB + NEO_KHZ800);

#define NOTE_B0 31
#define NOTE_C1 33
#define NOTE_CS1 35
#define NOTE_D1 37
#define NOTE_DS1 39
#define NOTE_E1 41
#define NOTE_F1 44
#define NOTE_FS1 46
#define NOTE_G1 49
#define NOTE_GS1 52
#define NOTE_A1 55
#define NOTE_AS1 58
#define NOTE_B1 62
#define NOTE_C2 65
#define NOTE_CS2 69
#define NOTE_D2 73
#define NOTE_DS2 78
#define NOTE_E2 82
#define NOTE_F2 87
#define NOTE_FS2 93
#define NOTE_G2 98
#define NOTE_GS2 104
#define NOTE_A2 110
#define NOTE_AS2 117
#define NOTE_B2 123
#define NOTE_C3 131
#define NOTE_CS3 139
#define NOTE_D3 147
#define NOTE_DS3 156
#define NOTE_E3 165
#define NOTE_F3 175
#define NOTE_FS3 185
#define NOTE_G3 196
#define NOTE_GS3 208
#define NOTE_A3 220
#define NOTE_AS3 233
#define NOTE_B3 247
#define NOTE_C4 262
#define NOTE_CS4 277
#define NOTE_D4 294
#define NOTE_DS4 311
#define NOTE_E4 330
#define NOTE_F4 349
#define NOTE_FS4 370
#define NOTE_G4 392
#define NOTE_GS4 415
#define NOTE_A4 440
#define NOTE_AS4 466
#define NOTE_B4 494
#define NOTE_C5 523
#define NOTE_CS5 554
#define NOTE_D5 587
#define NOTE_DS5 622
#define NOTE_E5 659
#define NOTE_F5 698
#define NOTE_FS5 740
#define NOTE_G5 784
#define NOTE_GS5 831
#define NOTE_A5 880
#define NOTE_AS5 932
#define NOTE_B5 988
#define NOTE_C6 1047
#define NOTE_CS6 1109
#define NOTE_D6 1175
#define NOTE_DS6 1245
#define NOTE_E6 1319
#define NOTE_F6 1397
#define NOTE_FS6 1480
#define NOTE_G6 1568
#define NOTE_GS6 1661
#define NOTE_A6 1760
#define NOTE_AS6 1865
#define NOTE_B6 1976
#define NOTE_C7 2093
#define NOTE_CS7 2217
#define NOTE_D7 2349
#define NOTE_DS7 2489
#define NOTE_E7 2637
#define NOTE_F7 2794
#define NOTE_FS7 2960
#define NOTE_G7 3136
#define NOTE_GS7 3322
#define NOTE_A7 3520
#define NOTE_AS7 3729
#define NOTE_B7 3951
#define NOTE_C8 4186
#define NOTE_CS8 4435
#define NOTE_D8 4699
#define NOTE_DS8 4978

struct Color {
    int red;
    int green;
    int blue;
};

struct Color standard_colors[5] = {
    {
        255,
        0,
        0
    }, // red 
    {
        0,
        255,
        0
    }, // green  
    {
        0,
        0,
        255
    }, // blue 
    {
        85,
        10,
        138
    }, // purple
    {
        255,
        255,
        0
    } //  yellow 
};

struct Player {
    Color color;
    bool colorSelected;
};

struct Color defaultColor = {
    0,
    0,
    0
};

struct Player player[2];
int turn = 0;
int spotSelector = 0;
bool ok = true;
bool game = true;
int board[6][7];
int save;
long ts = 0;

bool checkWinner() {
    // check all the lines verticlay if there is any 4 in a row

    for (uint8_t i = 0; i < 6 - 3; i++) {
        for (uint8_t j = 0; j < 7; j++) {

            if (board[i][j] == turn && board[i + 1][j] == turn && board[i + 2][j] == turn && board[i + 3][j] == turn) {

                for (int k = 0; k < 5; k++) {

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor(j + (i + 1) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor(j + (i + 2) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor(j + (i + 3) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.show();

                    delay(500);

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor(j + (i + 1) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor(j + (i + 2) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor(j + (i + 3) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.show();

                    delay(500);
                }

                return true;
            }
        }
    }

    // check all the lines horisontaly if there is any 4 in a row
    for (uint8_t i = 0; i < 6; i++) {
        for (uint8_t j = 0; j < 7 - 3; j++) {
            if (board[i][j] == turn && board[i][j + 1] == turn && board[i][j + 2] == turn && board[i][j + 3] == turn) {

                for (int k = 0; k < 5; k++) {

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 1) + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 2) + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 3) + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.show();

                    delay(500);

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 1) + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 2) + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 3) + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.show();

                    delay(500);
                }

                return true;
            }
        }
    }

    // check all the lines on ascending diagonal if there is any 4 in a row
    for (uint8_t i = 3; i < 6; i++) {
        for (uint8_t j = 0; j < 7 - 3; j++) {
            if (board[i][j] == turn && board[i - 1][j + 1] == turn && board[i - 2][j + 2] == turn && board[i - 3][j + 3] == turn) {

                for (int k = 0; k < 5; k++) {

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 1) + (i - 1) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 2) + (i - 2) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j + 3) + (i - 3) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.show();

                    delay(500);

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 1) + (i - 1) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 2) + (i - 2) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j + 3) + (i - 3) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.show();

                    delay(500);
                }

                return true;
            }
        }
    }

    // check all the lines on descending diagonal if there is any 4 in a row
    for (uint8_t i = 3; i < 6; i++) {
        for (uint8_t j = 3; j < 7; j++) {
            if (board[i][j] == turn && board[i - 1][j - 1] == turn && board[i - 2][j - 2] == turn && board[i - 3][j - 3] == turn) {

                for (int k = 0; k < 5; k++) {

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j - 1) + (i - 1) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j - 2) + (i - 2) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.setPixelColor((j - 3) + (i - 3) * 7, playerSpotSelect.Color(155, 103, 60));
                    gamaeBoard.show();

                    delay(500);

                    gamaeBoard.setPixelColor(j + i * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j - 1) + (i - 1) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j - 2) + (i - 2) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.setPixelColor((j - 3) + (i - 3) * 7, playerSpotSelect.Color(0, 0, 0));
                    gamaeBoard.show();

                    delay(500);
                }

                return true;
            }
        }
    }
    return false;
}

void setup() {
    Serial.begin(9600);
    pinMode(Pl1RED_PIN, OUTPUT);
    pinMode(Pl1GREEN_PIN, OUTPUT);
    pinMode(Pl1BLUE_PIN, OUTPUT);

    pinMode(Pl2RED_PIN, OUTPUT);
    pinMode(Pl2GREEN_PIN, OUTPUT);
    pinMode(Pl2BLUE_PIN, OUTPUT);

    pinMode(BUZZER_PIN, OUTPUT);

    gamaeBoard.begin();
    playerSpotSelect.begin();
}

// compare 2 colors to see if there are the same or not
bool colorCompare(struct Color color1, struct Color color2) {
    if (color1.red != color2.red ||
        color1.green != color2.green ||
        color1.blue != color2.blue) {
        return false;
    }
    return true;
}

void clear() {
    analogWrite(Pl1RED_PIN, 0);
    analogWrite(Pl1GREEN_PIN, 0);
    analogWrite(Pl1BLUE_PIN, 0);

    analogWrite(Pl2RED_PIN, 0);
    analogWrite(Pl2GREEN_PIN, 0);
    analogWrite(Pl2BLUE_PIN, 0);
}

void clearP1() {

    analogWrite(Pl1RED_PIN, 0);
    analogWrite(Pl1GREEN_PIN, 0);
    analogWrite(Pl1BLUE_PIN, 0);
}

void clearP2() {

    analogWrite(Pl2RED_PIN, 0);
    analogWrite(Pl2GREEN_PIN, 0);
    analogWrite(Pl2BLUE_PIN, 0);

}

void setPlayer() {
    player[0].color = defaultColor;
    player[1].color = defaultColor;
    player[0].colorSelected = false;
    player[1].colorSelected = false;

}

void setBoardMatrix() {
    for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 7; j++) {
            board[i][j] = 3;
        }
    }
}
// set the color of a player
void setPlayerColor(int player_nr) {

    int colorSelect = 0;
    int buttonValue;
    while (!(player[player_nr].colorSelected)) {

        buttonValue = analogRead(A0);
        if (buttonValue >= 990 && buttonValue <= 1010) {

            if (colorSelect > 0) {
                colorSelect--;
            } else {
                colorSelect = 4;
            }

        } else if (buttonValue >= 950 && buttonValue <= 970) {
            if (player_nr == 0) {
                player[player_nr].color = standard_colors[colorSelect];
                player[player_nr].colorSelected = true;
                break;
            } else {

                if (!(colorCompare(standard_colors[colorSelect], player[0].color))) {
                    player[player_nr].color = standard_colors[colorSelect];
                    player[player_nr].colorSelected = true;
                    break;
                }
            }
        } else if (buttonValue >= 900 && buttonValue <= 930) {

            if (colorSelect < 4) {

                colorSelect++;
            } else {
                colorSelect = 0;
            }
        }

        if (player_nr == 0) {
            analogWrite(Pl1RED_PIN, 0);
            analogWrite(Pl1GREEN_PIN, 0);
            analogWrite(Pl1BLUE_PIN, 0);

            delay(500);

            analogWrite(Pl1RED_PIN, standard_colors[colorSelect].red);
            analogWrite(Pl1GREEN_PIN, standard_colors[colorSelect].green);
            analogWrite(Pl1BLUE_PIN, standard_colors[colorSelect].blue);

            delay(500);
        } else if (player_nr == 1) {

            analogWrite(Pl2RED_PIN, 0);
            analogWrite(Pl2GREEN_PIN, 0);
            analogWrite(Pl2BLUE_PIN, 0);

            delay(500);

            analogWrite(Pl2RED_PIN, standard_colors[colorSelect].red);
            analogWrite(Pl2GREEN_PIN, standard_colors[colorSelect].green);
            analogWrite(Pl2BLUE_PIN, standard_colors[colorSelect].blue);

            delay(500);
        }

    }
    delay(1000);
}

void loop() {
    if (game) {
        if (ok) {
            setBoardMatrix();
            setPlayer();
        }

        if (!(player[0].colorSelected)) {
            setPlayerColor(0);
        }
        if (!(player[1].colorSelected)) {
            setPlayerColor(1);
        }

        if (ok) {
            delay(1000);
            clear();
            ok = false;
        }

        if (turn == 0) {
            analogWrite(Pl1RED_PIN, player[turn].color.red);
            analogWrite(Pl1GREEN_PIN, player[turn].color.green);
            analogWrite(Pl1BLUE_PIN, player[turn].color.blue);
        } else {
            analogWrite(Pl2RED_PIN, player[turn].color.red);
            analogWrite(Pl2GREEN_PIN, player[turn].color.green);
            analogWrite(Pl2BLUE_PIN, player[turn].color.blue);
        }

        playerSpotSelect.clear();
        playerSpotSelect.show();
        delay(300);

        playerSpotSelect.setPixelColor(spotSelector, playerSpotSelect.Color(player[turn].color.red, player[turn].color.green, player[turn].color.blue));
        playerSpotSelect.show();
        delay(500);

        int buttonValue;
        buttonValue = analogRead(A0);
        if (buttonValue >= 985 && buttonValue <= 1010) {

            if (spotSelector > 0) {
                spotSelector--;
            } else {
                spotSelector = 6;
            }

        } else if (buttonValue >= 940 && buttonValue <= 970 && board[0][spotSelector] == 3) {

            playerSpotSelect.clear();
            playerSpotSelect.show();
            save = 0;
            while (1) {

                if (save <= 6 && board[save + 1][spotSelector] == 3) {

                    gamaeBoard.setPixelColor(spotSelector + save * 7, gamaeBoard.Color(player[turn].color.red, player[turn].color.green, player[turn].color.blue));
                    gamaeBoard.show();

                    delay(500);

                    gamaeBoard.setPixelColor(spotSelector + save * 7, gamaeBoard.Color(0, 0, 0));
                    gamaeBoard.show();

                    delay(500);

                    save++;
                } else {
                    board[save][spotSelector] = turn;
                    gamaeBoard.setPixelColor(spotSelector + save * 7, gamaeBoard.Color(player[turn].color.red, player[turn].color.green, player[turn].color.blue));
                    gamaeBoard.show();

                    delay(500);
                    spotSelector = 0;
                    break;
                }
            }
            delay(500);

            if (checkWinner()) {

                gamaeBoard.clear();
                gamaeBoard.show();

                for (uint8_t nLoop = 0; nLoop < 2; nLoop++) {
                    tone(BUZZER_PIN, NOTE_A5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_B5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_C5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_B5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_C5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_D5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_C5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_D5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_E5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_D5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_E5);
                    delay(500);
                    tone(BUZZER_PIN, NOTE_E5);
                    delay(500);
                }
                noTone(BUZZER_PIN);

                game = false;
                turn = 0;
            } else {

                if (turn == 0 && game) {
                    turn = 1;
                    clearP1();
                } else {
                    turn = 0;
                    clearP2();
                }
            }

        } else if (buttonValue >= 890 && buttonValue <= 930) {

            if (spotSelector < 6) {
                spotSelector++;
            } else {
                spotSelector = 0;
            }

        }
    } else {
        gamaeBoard.clear();
        clearP1();
        clearP2();
        playerSpotSelect.clear();

        game = true;
        ok = true;
    }

}
